//+------------------------------------------------------------------+
//|                                                   newshunter.mq4 |
//|                                                         |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""

//---- input parameters
extern int       LotSize=1;  // 
extern int       StopLoss=20; //-  
extern int       Slip=3; //
extern int       Gap=20;//   
extern int       NOrds=5;//   
extern int       Level=20;//     
extern int       TralingStart=10;
extern int       TralingStop=20;

extern int       HourShift=0; //    
extern int       Minutes=5;  //   
extern int       LifeTime=15; //     

extern bool      ShowMarketInfo=true;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

#define MAX_NEWS 1000
#define MAX_ORD 20

#define NEWS_INIT -1
#define NEWS_WAIT 0
#define NEWS_SET 1
#define NEWS_RUN 2

#define ACT_EMPTY 0
#define ACT_OPEN  1
#define ACT_CLOSEPROFIT 2
#define ACT_CLOSELOSS   4



datetime dtNews[MAX_NEWS]; //  
int Labels[MAX_NEWS];

int actNews[MAX_NEWS]; //,   
int iSymbs[MAX_NEWS];
int /*NextNews,*/ NewsMode;
int OrdTick[MAX_ORD], nOrd;
datetime NextNews;
int NextLabel;

//      
double ModeLow;
double ModeHigh;
double ModeTime;
double ModeBid;
double ModeAsk;
double ModePoint;
double ModeDigits;
double ModeSpread;
double ModeStopLevel;
double ModeLotSize;
double ModeTickValue;
double ModeTickSize;
double ModeSwapLong;
double ModeSwapShort;
double ModeStarting;
double ModeExpiration;
double ModeTradeAllowed;
double ModeMinLot;
double ModeLotStep;

int GetMarketInfo()
  {
   //    
   ModeLow = MarketInfo(Symbol(), MODE_LOW);
   ModeHigh = MarketInfo(Symbol(), MODE_HIGH);
   ModeTime = MarketInfo(Symbol(), MODE_TIME);
   ModeBid = MarketInfo(Symbol(), MODE_BID);
   ModeAsk = MarketInfo(Symbol(), MODE_ASK);
   ModePoint = MarketInfo(Symbol(), MODE_POINT);
   ModeDigits = MarketInfo(Symbol(), MODE_DIGITS);
   ModeSpread = MarketInfo(Symbol(), MODE_SPREAD);
   ModeStopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   ModeLotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   ModeTickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
   ModeTickSize = MarketInfo(Symbol(), MODE_TICKSIZE);
   ModeSwapLong = MarketInfo(Symbol(), MODE_SWAPLONG);
   ModeSwapShort = MarketInfo(Symbol(), MODE_SWAPSHORT);
   ModeStarting = MarketInfo(Symbol(), MODE_STARTING);
   ModeExpiration = MarketInfo(Symbol(), MODE_EXPIRATION);
   ModeTradeAllowed = MarketInfo(Symbol(), MODE_TRADEALLOWED);
   ModeMinLot = MarketInfo(Symbol(), MODE_MINLOT);
   ModeLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   //    
   if ( ShowMarketInfo == True )
     {
       Print("ModeLow:",ModeLow);
       Print("ModeHigh:",ModeHigh);
       Print("ModeTime:",ModeTime);
       Print("ModeBid:",ModeBid);
       Print("ModeAsk:",ModeAsk);
       Print("ModePoint:",ModePoint);
       Print("ModeDigits:",ModeDigits);
       Print("ModeSpread:",ModeSpread);
       Print("ModeStopLevel:",ModeStopLevel);
       Print("ModeLotSize:",ModeLotSize);
       Print("ModeTickValue:",ModeTickValue);
       Print("ModeTickSize:",ModeTickSize);
       Print("ModeSwapLong:",ModeSwapLong);
       Print("ModeSwapShort:",ModeSwapShort);
       Print("ModeStarting:",ModeStarting);
       Print("ModeExpiration:",ModeExpiration);
       Print("ModeTradeAllowed:",ModeTradeAllowed);
       Print("ModeMinLot:",ModeMinLot);
       Print("ModeLotStep:",ModeLotStep);
     }
   return (0);
  }

/*
int OpenOrder(int cmd, double price)
{// ,        .
// .     -1
      
   for(int i=0; i<MAX_ORD; i++)
   {
     if(OrdTick[i]==-1) break;
   }
   if(i==MAX_ORD)
   {
      Print("Too many orders opened");
      return (-1);
   }
    
   if((cmd==OP_BUY)||(cmd==OP_BUYLIMIT)||(cmd==OP_BUYSTOP))
      int tick=OrderSend(Symbol(),cmd,price,3,price-StopLoss*Point,0,NULL,0,0,Red);
   else      
      tick=OrderSend(Symbol(),cmd,price,3,price+StopLoss*Point,0,NULL,0,0,Green); 
   if(tick==-1)
   {
       Print("Order opening error",GetLastError());
   }
   else nOrd++;
   OrdTick[i]=tick;
   return (tick);   
}      
*/
/*
int SymEncode(string sym)
{
   if(sym=="EURUSD") return(0);
   if(sym=="GBPUSD") return(1);
   if(sym=="USDJPY") return(2);
   if(sym=="AUDUSD") return(3);
   return(-1);   
}

string SymDecode(int sym)
{
   switch(sym)
   {
      case 0 : return("EURUSD");
      case 1 : return("GBPUSD");
      case 2 : return("USDJPY");
      case 3 : return("AUDUSD");
      default : return("EMPTY");
   }
}
*/

int init()
{
   //NewsMode=NEWS_INIT;
   NewsInit();
   return (0);   
}

string StrTrim(string s)
{
   return (StringTrimLeft(StringTrimRight(s)));
}

datetime FindNextNews()
{
   datetime cdt=MarketInfo(Symbol(), MODE_TIME);
   datetime dt=cdt;
   int idx=-1;
   for(int i=0; i<MAX_NEWS; i++)
   {
      if(dtNews[i] > cdt)
      {
         if(dt > (dtNews[i] - cdt)) 
         {
            dt=dtNews[i] - cdt;
            idx=i;
         }
      }
   }
   if(idx==-1) return(-1);
   return (idx);  
}

int log;

int NewsInit()
{//          
   datetime dt, dc;
   string ss, sd, sm;
   int i, n;
   string logname=StringConcatenate(Symbol(),"_log.txt");
   
   
   int h=FileOpen("news.txt", FILE_CSV|FILE_READ);
   log=FileOpen(logname, FILE_CSV|FILE_WRITE, ' ');
   
   dc=MarketInfo(Symbol(), MODE_TIME);
   FileWrite(log, "Start datetime is ", TimeToStr(dc));
   
   
   NextNews=-1;
   NewsMode=NEWS_WAIT;
   if(h==-1)
   {
      Print("Cannot open news file");
      return(0);
   }
   for(i=0; i<MAX_NEWS; i++) 
   {// 
      dtNews[i]=-1;
      Labels[i]=-1;
      actNews[i]=ACT_EMPTY;
   }
   i=0; n=0;
   while(!FileIsEnding(h))
   {// 
      sd=FileReadString(h); // 
      ss=FileReadString(h); // 
      sm=FileReadString(h); // 
      FileReadString(h);    //  
      sd=StrTrim(sd); // 
      ss=StrTrim(ss);
      sm=StrTrim(sm);
      dt=StrToTime(sd);     //    datetime
      if((ss==Symbol())&& (dt >= dc))
      {
         if(i < MAX_NEWS)
         {
            dtNews[i]=dt + HourShift*3600; 
            actNews[i]=ACT_OPEN; 
            Labels[i]=StrToInteger(sm);
            n++;            
            FileWrite(log, i, TimeToStr(dtNews[i]), ss, Labels[i]);
         }         
         i++;
      }
   }
   FileWrite(log, "Total records found:", i, "Saved: ", n);   
   FileClose(h);
   
   int idx=FindNextNews();
   if(idx==-1) FileWrite(log, "No actual news in this file");
   else 
   {
      NextNews=dtNews[idx];
      NextLabel=Labels[idx];
      FileWrite(log, "Next news time: ", TimeToStr(NextNews), "Next news label: ", NextLabel);
   }   
   FileWrite(log,"***********************************************************");
   FileFlush(log);
   return(0);
}
  
  

  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   FileClose(log);
   return(0);
}

void OpenOrder(int op, double price)
{//   
   double sl;
   int op1;
   color col;
   if(op==OP_BUY) 
   {
      op1=OP_BUYSTOP;
      sl=price - StopLoss*Point;      
      col=Blue;
   }
   else
   {
      op1=OP_SELLSTOP;
      sl=price + StopLoss*Point;
      col=Red;
   }
   if(OrderSend(Symbol(),op1,LotSize,price,Slip,sl,0,NULL,0,0,col)==-1)
   {
      Print("OrderSend error: ", GetLastError());
   }   
}


int Trailing()
{//      .
   int n=0;
   double profit;
   double sl;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS))
      {
         switch(OrderType())
         {
            case OP_BUY :
               profit=Bid - OrderOpenPrice();
               if(profit > TralingStart*Point)
               {
                  sl=Bid - TralingStop*Point;
                  if(OrderStopLoss() < sl)
                  {
                     if(OrderModify(OrderTicket(),OrderOpenPrice(),sl,0,Green)==false)
                     {
                        Print("OrderModify error: ", GetLastError());                  
                     }              
                  }
               }              
               n++;
            break;
            
            case OP_SELL :
               profit=OrderOpenPrice() - Ask;
               if(profit > TralingStart*Point)
               {
                  sl=Ask + TralingStop*Point;
                  if(OrderStopLoss() > sl)
                  {
                     if(OrderModify(OrderTicket(),OrderOpenPrice(),sl,0,Green)==false)
                     {
                        Print("OrderModify error: ", GetLastError());                  
                     }              
                  }
               }
               n++;
            break;
            
            default : break;                             
         }     
      }
   }
   return (n);
}
  
void CloseOrders()
{
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS))
      {
         switch(OrderType())
         {
            case OP_BUY  :
               OrderClose(OrderTicket(),OrderLots(),Bid,Slip,CLR_NONE);
               break;
            case OP_SELL :
               OrderClose(OrderTicket(),OrderLots(),Ask,Slip,CLR_NONE);
            default :
               OrderDelete(OrderTicket());                              
         }
      }
   }
}  
  
int start()
{
   datetime dtCur;
//   datetime dtNw;
   int i;
   
   
      
   if(NextNews==-1) return(0);
   dtCur=CurTime();
   
          
   switch(NewsMode)
   {
      case NEWS_INIT :
         NewsInit();
         break;
         
      case NEWS_WAIT :  //          
         if(dtCur < (NextNews-Minutes*60)) break;         
         double hi=-1000000.0, lo=1000000.0, p;
         for(i=0; i<5; i++)
         {
            p=iHigh(Symbol(),0,i+1);
            if(hi < p) hi=p;  
            p=iLow(Symbol(),0,i+1);
            if(lo > p) lo=p;  
         }
         int stop=MarketInfo(Symbol(), MODE_STOPLEVEL); 
         int gap=Gap;
         if(stop > Gap) gap=stop;
         FileWrite(log, "#",NextLabel,"|",TimeToStr(dtCur),"|   hi =",hi,"  lo =",lo,"  stoplevel =", stop);
         hi += gap*Point;
         lo -= gap*Point;            
         
         double d=Level*Point;
         for(i=0; i<NOrds; i++)
         {
            OpenOrder(OP_BUY,  hi + i*d);
            OpenOrder(OP_SELL, lo - i*d);
         }
         NewsMode=NEWS_SET;  
                          
          break;      
          
      case NEWS_SET :
         Trailing();
         dtCur=CurTime();
         if(dtCur > (NextNews +  LifeTime*60))
         {
            CloseOrders();
            int idx=FindNextNews();
            NextNews=dtNews[idx];
            NextLabel=Labels[idx];
            NewsMode=NEWS_WAIT;
         }
         break;
            
                        
            
   }   
   return(0);
}

